C==================================================================
C     Subroutine to initialize the SM parameters common block
C==================================================================

      SUBROUTINE INITIALIZE_SM
      IMPLICIT NONE
      DOUBLE PRECISION V, MZ, MW, MTPOLE, MBMB, MCMC, MS, MTAU, MMU, 
     .     ALPHAEM,ALSMZ, VCB, VUS, VUB
      COMMON/SM/V,MZ,MW,MTPOLE,MBMB,MCMC,MS,MTAU,MMU,
     .     ALPHAEM,ALSMZ,VCB,VUS,VUB
      DOUBLE PRECISION PI
      DOUBLE PRECISION GF, CABIBBO, MDPOLE, MUPOLE, MELEC
      COMMON/MG5SM/GF,CABIBBO,MDPOLE,MUPOLE,MELEC
      PI = 4.D0*DATAN(1.D0)
      GF = 1.16637D-5
      MZ = 91.1876D0
c      MW = 80.399D0
c      MT = 172.D0
c      MB = 4.49D0
c      MC = 1.42D0
c      MS = 0.100D0
c      MTAU = 1.77682D0
c      MMU = 0.105658367D0
c      ALPHAEM = 1.D0/137.036D0
c      ALPHAS = 0.119D0
c      VCB = 0.0410D0
c      VUS = 0.2253D0
c      VUB = 0.0846D0*VCB
      MTPOLE = 1.72D2
      MBMB = 4.49D0
      MCMC = 1.42D0
      MS = 0.D0
      MTAU = 1.777D0
      MMU = 1.0566D-1
      ALPHAEM = 1.D0/1.279D2
      ALSMZ = 1.184D-1
      CABIBBO = 2.277360D-1
      VCB = 0.D0
      VUB = 0.D0
C Derived parameters:
      V = DSQRT(1.D0/DSQRT(2.D0)/GF)
      VUS = DSIN(CABIBBO)
      MW = DSQRT(MZ**2/2.D0 + DSQRT(MZ**4/4.D0 
     .     - PI*ALPHAEM*MZ**2/DSQRT(2.D0)/GF))
C More pole masses, for MG5
      MDPOLE = 5.04D-3
      MUPOLE = 2.55D-3
      MELEC = 5.11D-4

      CALL INIT_QCD
      RETURN
      END

